/*
OpenFire, a electrical Firework

License:
"OpenFire" by Jennifer Sirtl (jennifer.sirtl@mostfun.de) is licensed under CC BY 4.0

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons Lizenzvertrag" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a>
<br />Dieses Werk ist lizenziert unter einer <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Namensnennung 4.0 International Lizenz</a>.

*/

#include "config.h"

void Shoot_1(uint32_t c, uint8_t wait,uint8_t Shape_Num) 
{
  int Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip_Shoot];

  Pattern[0]=0;
  Pattern[1]=c & Shape[Shape_Num][4];
  Pattern[2]=c & Shape[Shape_Num][3];
  Pattern[3]=c & Shape[Shape_Num][2];
  Pattern[4]=c & Shape[Shape_Num][1];
  Pattern[5]=c & Shape[Shape_Num][0];
  if (Shape_Num!=2) {
    Pattern[6]=c & 0xFFFFFF;
  }
  else {
    Pattern[6]=c & 0x000000;       
  }
  Beginn=6;


  for (Frame=NUM_LEDS_Strip_Shoot-1;Frame>=-Beginn;Frame--){
    Led_Index=Frame;
    for(n=Beginn;n>=0;n--){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip_Shoot)){     
        leds_Shoot[Led_Index]=Pattern[n]; 
      }
      Led_Index++;  
    }
    FastLED.show();
    delay(wait);
  }
  return;
}

void Shoot_2(uint32_t c, uint8_t wait,uint8_t Shape_Num){
  int Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip_Shoot];

  Pattern[0]=0;
  Pattern[1]=c & Shape[Shape_Num][4];
  Pattern[2]=0;
  Pattern[3]=0;
  Pattern[4]=0;
  Pattern[5]=0;
  if (Shape_Num!=2) {
    Pattern[6]=c & 0xFFFFFF;
  }
  else {
    Pattern[6]=c & 0x000000;       
  }
  
  Beginn=6;
  
  for (Frame=NUM_LEDS_Strip_Shoot-1;Frame>=-Beginn;Frame--){
    Led_Index=Frame;
    for(n=Beginn;n>=0;n--){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip_Shoot)){     
        leds_Shoot[Led_Index]=Pattern[n]; 
      }
      Led_Index++;  
    }
    FastLED.show();
    delay(wait);
  }
  return;
}

void Shoot_3(uint32_t c, uint8_t wait,uint8_t Shape_Num) {
  int Frame;
  
  for (Frame=NUM_LEDS_Strip_Shoot-1;Frame>=0;Frame--){
    if (Frame==NUM_LEDS_Strip_Shoot-1){leds_Shoot[NUM_LEDS_Strip_Shoot-1]=c & Shape[Shape_Num][1]; }
    if (Frame==NUM_LEDS_Strip_Shoot-2){leds_Shoot[NUM_LEDS_Strip_Shoot-1]=0; }
    FastLED.show();
    delay(wait);  
  }
  return;
}
